<?php

namespace Itgro\SbrfAcquiring\Models;

use Illuminate\Database\Eloquent\Model;
use Itgro\SbrfAcquiring\Interfaces\OrderStatuses;

/**
 * Class SbrfAcquiringOrder
 * @package Itgro\SbrfAcquiring\Models
 *
 * @property mixed $order_id
 * @property string $external_id
 * @property string $received_at
 * @property integer $amount
 * @property string $status
 * @property mixed $metadata
 * @property created_at
 * @property updated_at
 */
class SbrfAcquiringOrder extends Model implements OrderStatuses
{
    protected $casts = [
        'metadata' => 'array'
    ];

    public function setStatusAttribute($status)
    {
        if (array_has(self::STATUS_BY_INTEGER, $status)) {
            $this->attributes['status'] = $this->getStatusByIndex($status);
            return;
        } else {
            $this->attributes['status'] = $status;
        }

    }

    public function getStatusByIndex($index)
    {
        return array_get( self::STATUS_BY_INTEGER, $index, OrderStatuses::STATUS_UNDEFINED);
    }
}
